import { Injectable } from '@nestjs/common';
import { DatabaseService, OptionalId } from '@uiii-lib/nestjs-database-postgres';

import { as } from '../core/helpers/object';

import { <%= classify(resourceName) %>, <%= classify(resourceName) %>Input } from './model/<%= resourceName %>';
import { <%= classify(resourceName) %>Row } from './model/db/<%= resourceName %>.row';

@Injectable()
export class <%= classify(resourceName) %>Repository {
	static readonly <%= camelize(resourceName) %>Table = '<%= tableName %>';

	constructor(private dbService: DatabaseService) {}

	async get<%= plural(classify(resourceName)) %>() {
		const rows = await this.dbService.query<<%= classify(resourceName) %>Row>(query => query
			.from(<%= classify(resourceName) %>Repository.<%= camelize(resourceName) %>Table)
		);

		return rows.map(row => this.rowTo<%= classify(resourceName) %>(row));
	}

	async get<%= classify(resourceName) %>ById(id: string) {
		const row = await this.dbService.queryOne<<%= classify(resourceName) %>Row>(query => query
			.from(<%= classify(resourceName) %>Repository.<%= camelize(resourceName) %>Table)
			.where('id', id)
		);

		return this.rowTo<%= classify(resourceName) %>(row);
	}

	async save<%= classify(resourceName) %>(<%= camelize(resourceName) %>: <%= classify(resourceName) %>Input) {
		const row = await this.dbService.upsert<<%= classify(resourceName) %>Row>(
			<%= classify(resourceName) %>Repository.<%= camelize(resourceName) %>Table,
			this.<%= camelize(resourceName) %>ToRow(<%= camelize(resourceName) %>),
			['id']
		);

		return this.rowTo<%= classify(resourceName) %>(row);
	}

	async remove<%= classify(resourceName) %>(id: string) {
		const rows = await this.dbService.remove<<%= classify(resourceName) %>Row>(<%= classify(resourceName) %>Repository.<%= camelize(resourceName) %>Table, query => query
			.where('id', id)
		);

		return this.rowTo<%= classify(resourceName) %>(rows[0]);
	}

	protected <%= camelize(resourceName) %>ToRow(<%= camelize(resourceName) %>: <%= classify(resourceName) %>Input) {
		return as<OptionalId<<%= classify(resourceName) %>Row>>({
			id: <%= camelize(resourceName) %>.id ? parseInt(<%= camelize(resourceName) %>.id) : undefined
		});
	}

	protected rowTo<%= classify(resourceName) %>(row: <%= classify(resourceName) %>Row): <%= classify(resourceName) %>
	protected rowTo<%= classify(resourceName) %>(row: <%= classify(resourceName) %>Row|undefined): <%= classify(resourceName) %>|undefined
	protected rowTo<%= classify(resourceName) %>(row: <%= classify(resourceName) %>Row|undefined): <%= classify(resourceName) %>|undefined {
		if (!row) {
			return undefined;
		}

		return as<<%= classify(resourceName) %>>({
			id: row.id.toString()
		});
	}
}
